/**
 * # CHAPTER #
 * ============================================================================
 * xtclassifyѤڴϢؿ
 * ============================================================================
 */

#include <musashi.h>
#include <condition.h>
#include <classTable.h>
#include <bonsai.h>
#include <tree.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <float.h>

extern MssOptFLD optPAT;
extern MssOptFLD optNUM;
extern MssOptFLD optCAT;
extern MssOptFLD optCLS;
extern MssOptINF optTST;
extern MssOptINF optCST;
extern MssOptDBL optCNF;
extern MssOptINT optMIN;

extern struct mssFields *fpat;
extern struct mssFields *fnum;
extern struct mssFields *fcat;
extern struct mssFields *fcls;

extern int   ClassSize;
extern char  catCombi[1024][10];
extern int   usedRandSeed;

extern struct mssGlobalVariables mssGV;
extern struct mssPMMLvariables mssPV;

/*ĥ꡼ˡData򻲾Ȥ뤿Υݥ*/
struct Pointer {
  int  recCnt;        /*ǡ*/
  int *recNo;         /*ƬιԿ*/
  double *weight;     /*NULLͤθrecNoб륱νŤ*/
};

/**
 * # FUNCTION #
 *٥ΥåȴϢ
 *  1. ٥Υå
 *  2. ǿ٥Υå
 *  3. ꡼տΥ
 */
static void setLevel(struct Node *node,struct Tree *tree, int level){

  /*٥Υå*/
  node->level=level;

  /*ǿ٥ι*/
  if(level>tree->deepest) tree->deepest=level;

  /*꡼դʤХ꥿*/
  if( 0==node->nodeType || node->pruned){
    tree->leafCnt++;
    return;
  }

  setLevel(node->uNode,tree,level+1);
  setLevel(node->mNode,tree,level+1);
}

/**
 * # FUNCTION #
 * ĥ꡼ΥΡɤ򼡡˲Ƶؿ
 */
static struct Node **freeTreeTbl(
  struct Node  *node,
  struct Node **nodeTbl,
  int          *nodeCnt){

  int cnt;
  if(node->attType==2){ /*ƥΥꥹȤ*/
    mssFree( node->catList );
  } 
  if(node->nodeType==0){ /*leafʤ*/
    return(nodeTbl);
  }else{
    cnt=(*nodeCnt);
    cnt=cnt+2;
    nodeTbl=mssRealloc(nodeTbl,sizeof(struct Tree *)*cnt,"freeTree");
    *(nodeTbl+cnt-2) = node->uNode;
    *(nodeTbl+cnt-1) = node->mNode;
    *nodeCnt=cnt;
  }
  nodeTbl=freeTreeTbl(node->uNode,nodeTbl,nodeCnt);
  nodeTbl=freeTreeTbl(node->mNode,nodeTbl,nodeCnt);
  return(nodeTbl);
}

/**
 * # FUNCTION #
 * ץ빽¤ΤΥԡ(toγƼΰݤޤ)
 */
static struct Data *cpyDatMapReg(struct Data *from){

  int i,j;
  struct Data *to;

  to         = mssCalloc(sizeof(struct Data),"cpySmp");

  /*==============================================*/
  /*ڤˤäѤѿϥݥ󥿤Ȥƥԡ*/
  /*==============================================*/
  to->numCnt = from->numCnt;
  to->num    = from->num;
  to->numNull= from->numNull;
  to->catCnt = from->catCnt;
  to->cat    = from->cat;
  to->catNull= from->catNull;
  to->cls    = from->cls;



  /*====================================================*/
  /*ѥܤϷڤˤäѤΤǡΤ򥳥ԡ*/
  /*====================================================*/
  to->patCnt = from->patCnt;
  if(to->patCnt>0){
    to->pat    = mssCalloc( to->patCnt * sizeof(struct Pattern) ,"cpyDat" );

    for(i=0; i<to->patCnt; i++){
      to->patNull= from->patNull;

      (to->pat+i)->numPat=(from->pat+i)->numPat;

      /*MapΥԡ*/
      (to->pat+i)->map=mssCalloc(sizeof(struct Map), "cpySmp");
      (to->pat+i)->map->alpOrg = (from->pat+i)->map->alpOrg;
      (to->pat+i)->map->numAlp = (from->pat+i)->map->numAlp;
      (to->pat+i)->map->alp
        =mssCalloc(sizeof(usint)*((from->pat+i)->map->alpSiz+1), "cpySmp");
      (to->pat+i)->map->idx
        =mssCalloc(sizeof(usint)*((from->pat+i)->map->alpSiz+1), "cpySmp");
      (to->pat+i)->map->alpSiz=(from->pat+i)->map->alpSiz;
      (to->pat+i)->map->idxSiz=(from->pat+i)->map->idxSiz;
      strcpyUSI((to->pat+i)->map->alp,(from->pat+i)->map->alp);
      strcpyUSI((to->pat+i)->map->idx,(from->pat+i)->map->idx);

      /*regTblΥԡ*/
      (to->pat+i)->regTbl=mssMalloc(sizeof(struct RegTbl),"spySmp");
      (to->pat+i)->regTbl->reg =
        mssCalloc(sizeof(struct Regexp)*(from->pat+i)->regTbl->cnt,"scr");
      (to->pat+i)->regTbl->cnt= (from->pat+i)->regTbl->cnt;
      for(j=0; j<(to->pat+i)->regTbl->cnt; j++){
        cpReg( (to  ->pat+i)->regTbl->reg+j,
               (from->pat+i)->regTbl->reg+j);
      }
    }
  }
  return(to);
}

/**
 * # FUNCTION #
 * cpyDatMapRegǥԡ줿ΰβ
 */
static void freeDatMapReg(struct Data *dat){

  int i;

  if(dat->patCnt==0) return;

  for(i=0; i<dat->patCnt; i++){
    /*Mapfree*/
    mssFree( (dat->pat+i)->map->alp );
    mssFree( (dat->pat+i)->map->idx );
    mssFree( (dat->pat+i)->map );

    /*regTblfree*/
    mssFree( (dat->pat+i)->regTbl->reg );
    mssFree( (dat->pat+i)->regTbl );
  }
  mssFree(dat->pat);
  mssFree(dat);
}

/**
 * # FUNCTION #
 * ΥǡڤΥΡɤƤϤᡢͽ¬饹Ƶؿ
 */
static void predictTreeSub(
  double clsWeight[],
  struct Node *this,
  struct Data *dat,
  int recNo,
  double weight,
  struct Tree *tree){

  usint index[MaxPatLen];
  double mWeight;
  double uWeight;
  int isNull=0;
  int match=0;

  /*꡼դãСweightclsWeightơ֥˥åȤ롣*/
  if( 0==this->nodeType || this->pruned ){
    clsWeight[this->cls]+=weight;
    return;
  }

  /*ߥΡɤξܤǡNULLξ
    ˤweight򤫤ƺƵ*/
  switch(this->attType){
  case 0:
    isNull=*(*(dat->patNull+this->attFldNo)+recNo);
    break;
  case 1:
    isNull=*(*(dat->numNull+this->attFldNo)+recNo);
    break;
  case 2:
    isNull=*(*(dat->catNull+this->attFldNo)+recNo);
    break;
  }
  if( isNull ){
    mWeight=weight * this->trnCnt.mRatio;
    uWeight=weight * (1-this->trnCnt.mRatio);
    predictTreeSub(clsWeight, this->mNode,dat,recNo,mWeight,tree);
    predictTreeSub(clsWeight, this->uNode,dat,recNo,uWeight,tree);
  } else {

    /*ˤmatch⤷unmatchΡɤ򤿤ɤ*/
    switch(this->attType){
    case 0:
      /*ѥ°ϡalphabet-indexΥǡɬפʤ
        ꥸʥΥե٥åȥѥ󤫤饤ǥå줿ǡ
        θmatch,unmatchꤹ(ȥ졼˥󥰤ʤʤƥ
        ǡͽ¬ݤɬפȤʤ롣*/
      alpStr2idxStr(index,
                    getStrListUSI((dat->pat+this->attFldNo)->patAlp,recNo),
                    (tree->dat->pat+this->attFldNo)->map);
      match=regCmp(index,
        (tree->dat->pat+this->attFldNo)->regTbl->reg+this->attPatNo);

      /*match=(int)*((dat->pat+(this->attFldNo))->att[this->attPatNo]+recNo);*/
      break;
    case 1:
      match= *(*(dat->num+this->attFldNo)+recNo) <= this->numTH;
      break;
    case 2:
      match= this->catList[*((dat->cat+this->attFldNo)->val+recNo)]=='M';
      break;
    }
    if( match ){
      predictTreeSub(clsWeight, this->mNode,dat,recNo,weight,tree);
    }else{
      predictTreeSub(clsWeight, this->uNode,dat,recNo,weight,tree);
    } 
  }
}

/**
 * # FUNCTION #
 * ǡ(dat)Τ쥳(rec)(tree)ͽ¬륯饹֤ͤؿ
 */
static int predictTree( struct Tree *tree, struct Data *dat, int recNo){
  double clsWeight[MaxClsLen];
  int maxCls=0;
  double maxClsWeight=0;
  int i;

  for(i=0; i<MaxClsLen; i++) clsWeight[i]=0;
  predictTreeSub(clsWeight, tree->topNode, dat, recNo,1,tree);

  for(i=0; i<dat->cls->cnt; i++){
    if(maxClsWeight<clsWeight[i]){
      maxCls=i;
      maxClsWeight=clsWeight[i];
    }
  }

  return(maxCls);
}

/**
 * # FUNCTION #
 * ǡ鷺ɤ߹ߡClassificationTable˷򥻥åȤ
 * åȤ줿ơ֥֤
 */
struct ClsTbl *setClsTbl( struct Data *dat, struct Tree *tree){
  struct ClsTbl *ct;
  int predictedClass;
  int actualClass;
  int i;

  ct=mssCalloc(sizeof(struct ClsTbl),"initClsTbl");

  for(i=0; i<dat->cnt; i++){
    actualClass=*(dat->cls->chr+i);
    predictedClass=predictTree(tree,dat,i);
    ct->cnt[actualClass][predictedClass]++;
  }

  return(ct);
}
  
/**
 * # SECTION #
 * ----------------------------------------------------------------------------
 * ڤĹϢ
 * ----------------------------------------------------------------------------
 */

/**
 * # FUNCTION #
 * ѥ̥饹̷
 */
static void setCndCntPat(
  struct CndCnt  *cnt,
  struct Pattern *pat,
  char           *patNull,
  struct Class   *cls,
  struct Pointer *pnt,
  int             attNo){

  int i;

  for(i=0; i<pnt->recCnt; i++){
    if(*(patNull+*(pnt->recNo+i))==1){/*NULL!!*/
      cnt->nCnt[(int)(*(cls->chr+*(pnt->recNo+i)))]+=*(pnt->weight+i);
      cnt->mCount++;
      cnt->uCount++;
    }else{
      if( 0 == *(pat->att[attNo]+*(pnt->recNo+i)) ){
        cnt->uCnt[(int)*(cls->chr+*(pnt->recNo+i))]+=*(pnt->weight+i);
        cnt->utCnt+=*(pnt->weight+i);
        cnt->uCount++;
      }else{
        cnt->mCnt[(int)*(cls->chr+*(pnt->recNo+i))]+=*(pnt->weight+i);
        cnt->mtCnt+=*(pnt->weight+i);
        cnt->mCount++;
      }
    }
  }
}

/**
 * # STRUCT #
 * °ͽ˥Ȥ뤿ι¤
 */
struct NumCls {
  double num;
  char   cls;
  double weight; /*NULL򴪰ƤŤ*/
};

/**
 * # FUNCTION #
 * °ͽ˥Ȥ
 */
static int qscmp3(const void **a, const void **b){
  double x,y;
  x=((struct NumCls *)a)->num;
  y=((struct NumCls *)b)->num;
  if(x>y)      return(1);
  else if(x<y) return(-1);
  else         return(0);
}

/**
 * # FUNCTION #
 * °ξ̥饹̷
 */
static double setCndCntNum(
  struct CndCnt  *cnt,
  double         *num,
  char           *numNull,
  struct Class   *cls,
  struct Pointer *pnt,
  struct Cost    *cost){

  struct CndCnt  tmpCnt;
  struct NumCls *tbl;
  double bestTh;
  double th;
  double bestSv;
  int i,j;

  /* NumCls¤Τΰ*/
  tbl=mssMalloc(pnt->recCnt * sizeof(struct NumCls),"setCndCntNum");

  /*°͡饹ͤNumCls¤Τ˥å*/
  /*ƱtmpCnt¤Τ*/
  iniCndCnt(&tmpCnt,cost);
  j=0;
  for(i=0; i<pnt->recCnt; i++){
    if(*(numNull+*(pnt->recNo+i))==1){/*NULL!!*/
      tmpCnt.nCnt[(int)(*(cls->chr+*(pnt->recNo+i)))]+=*(pnt->weight+i);
      tmpCnt.mCount++;
      tmpCnt.uCount++;
      tmpCnt.nCount++;
    }else{
      (tbl+j)->num   =*(num+*(pnt->recNo+i));
      (tbl+j)->cls   =*(cls->chr+*(pnt->recNo+i));
      (tbl+j)->weight=*(pnt->weight+i);
      tmpCnt.uCnt[(int)((tbl+j)->cls)]+=*(pnt->weight+i);
      tmpCnt.utCnt+=*(pnt->weight+i);
      tmpCnt.total+=*(pnt->weight+i);
      tmpCnt.uCount++;
      j++;
    }
  }

  /*ͽ¤Ѥ*/
/*
  qsort(tbl,j,sizeof(struct NumCls),
                       (int (*)(const void *, const void *))qscmp3);
*/
  qsort5(tbl,j,sizeof(struct NumCls), (int (*))qscmp3);

  bestTh=0;
  th=0;
  bestSv=99999;
  for(i=0; i<j; i++){
    th=(tbl+i)->num;
    tmpCnt.uCnt[(int)(tbl+i)->cls]-=(tbl+i)->weight;
    tmpCnt.mCnt[(int)(tbl+i)->cls]+=(tbl+i)->weight;
    tmpCnt.utCnt-=(tbl+i)->weight;
    tmpCnt.mtCnt+=(tbl+i)->weight;
    tmpCnt.mCount++;
    tmpCnt.uCount--;

    if( i!=j-1 ){ /*ǽ쥳ɤǤʤʤ*/
      if(th == (tbl+i+1)->num){ /*Υ쥳ɤͤƱʤcontinue*/
        continue;
      }
    }

    /*̥饹֥ȥԡη׻*/
    calCndCnt(&tmpCnt);
    calCndCntSplit(&tmpCnt);

    /* °ι */ 
    if( tmpCnt.splitAfter < bestSv){
      cpyCndCnt(cnt,&tmpCnt);
      bestSv=tmpCnt.splitAfter;
      if( i!=pnt->recCnt-1 ) bestTh=(th+(tbl+i+1)->num)/(double)2;
      else                   bestTh=th;
    }
  }

  mssFree(tbl);
  return(bestTh);
}

#define ValClsCnt(x,y) (*(valClsCnt+(x)*cls->cnt+(y)))

/**
 * # FUNCTION #
 * ƥ꡼°ξ̥饹̷
 * ƥ꡼Match,Unmatchɽ֤
 *   ex) MMUUUMUM
 */
static char *setCndCntCat(
  struct CndCnt   *cnt,
  struct Category *cat,
  char            *catNull,
  struct Class    *cls,
  struct Pointer  *pnt,
  struct Cost     *cost){

  int end[]={2,4,8,16,32,64,128,256,512,1024};
  struct CndCnt  tmpCnt;
  double bestSv=99999;
  int    bestCombi=0;
  char  *catList=NULL;
  int    improve;
  int    moveCat=-1;
  int i,j,k;

  double *valClsCnt;
  int *valRecCnt;    /*쥳ɷ*/
  int nulRec; /*nullΥ쥳ɷ*/
  int catVal,clsVal;
  double nulCnt[MaxClsLen];

  char combiNull[11];
  char *bestCombiNull=NULL;
  double total;

  for(i=0; i<ClassSize; i++){
    nulCnt[i]=0;
  }

  /* ƥ꡼classɽκ */
  /* valClsCnt[val][class] ΰ*/
  valClsCnt=mssCalloc(cat->cnt*cls->cnt*sizeof(double),"setCndCntCat1");
  valRecCnt=mssCalloc(cat->cnt*sizeof(int),"setCndCntCat1");
  nulRec=0;
  for(i=0; i<pnt->recCnt; i++){
    if(*(catNull+*(pnt->recNo+i))==1){/*NULL!!*/
      nulCnt[(int)(*(cls->chr+*(pnt->recNo+i)))]+=*(pnt->weight+i);
      nulRec++;
    }else{
      catVal=     *(cat->val+*(pnt->recNo+i));
      clsVal=(int)*(cls->chr+*(pnt->recNo+i));
      ValClsCnt(catVal,clsVal)+=*(pnt->weight+i);
      (*(valRecCnt+catVal))++;
    }
  }

  /*  ɽɽ */
  /*
  for(i=0; i<cat->cnt; i++){
    printf(" val=%d : ",i);
    for(j=0; j<cls->cnt; j++){
      printf("cls[%d]=%d ",j,ValClsCnt(i,j));
    }
    printf("\n");
  }
  */

  /*tmpCnt¤Τ*/
  iniCndCnt(&tmpCnt,cost);

  /*=======================================================================*/
  /*ƥ꡼°ͤμʲʤСMatch,Unmatchȹ礻*/
  /*׻Ŭʬ롣                                 */
  /* catCombi[i][val]={M,U};                                               */
  /* i 0 1 2 .... */
  /* 0 M M M .... */
  /* 1 U M M .... */
  /* 2 M U M .... */
  /* 3 U U M .... */
  /* 4 M M U .... */
  /* 5 U M U .... */
  /* 6 M U U .... */
  /* 7 U U U .... */
  /*   ºݤĴ٤Τi=1to72ӡʤ1,3,5Ĵ٤ */
  /*   2ӤˤΤϡ07,16,25,34Ʊ̣ʤΤ*/ 
  if(cat->cnt <= 10){
    for(i=0; i<end[cat->cnt-1]-1; i=i+2){
      iniCndCnt(&tmpCnt,cost);
      /*NULLȿǤ*/
      for(j=0; j<ClassSize; j++){
        tmpCnt.nCnt[j]=nulCnt[j];
      }
      for(j=0; j<cat->cnt+1; j++){
        combiNull[j]='0';
      }

      tmpCnt.mCount=nulRec;
      tmpCnt.uCount=nulRec;
      for(j=0; j<cat->cnt; j++){ /*ƥμ*/
        total=0; /*ƥ꡼(j)ȡ벿狼򥫥Ȥ*/

        if(catCombi[i][j]=='M'){
          tmpCnt.mCount += *(valRecCnt+j);
        }else{
          tmpCnt.uCount += *(valRecCnt+j);
        }
 
        for(k=0; k<cls->cnt; k++){ /*饹*/
          if(catCombi[i][j]=='M'){
            tmpCnt.mCnt[k]+=ValClsCnt(j,k);
          }else{
            tmpCnt.uCnt[k]+=ValClsCnt(j,k);
          }
          total+=ValClsCnt(j,k);
        }

        /*ƥ(j)ʤХե饰ΩƤƤ(ɽʤ)*/
        if(total==0){
          combiNull[j]='N';
        }
      }

      /*̥饹֥ȥԡη׻*/
      calCndCnt(&tmpCnt);
      calCndCntSplit(&tmpCnt);
      /*prnCndCnt(&tmpCnt);*/

      /* °ι */ 
      if( tmpCnt.splitAfter < bestSv){
        cpyCndCnt(cnt,&tmpCnt);
        bestSv=tmpCnt.splitAfter;
        bestCombi=i;
        mssFree(bestCombiNull);
        bestCombiNull=mssStrdup(combiNull);
      } 
    }

    catList=mssCalloc(sizeof(char)*cat->cnt,"setCndCntCat2");
    for(j=0; j<cat->cnt; j++){
      if(*(bestCombiNull+j)=='N'){
        *(catList+j)='N';
      }else{
        *(catList+j)=catCombi[bestCombi][j];
      }
    }
    mssFree(bestCombiNull);

  /*=======================================================================*/
  /*ƥ꡼°ͤμۤʤСgreedy           */
  /*ɤʬ                                                       */
  }else{
    /*ͤȤơMatchȤư*/
    catList=mssCalloc(sizeof(char)*cat->cnt,"setCndCntCat3");
    /*NULLȿǤ*/
    for(j=0; j<ClassSize; j++){
      tmpCnt.nCnt[j]=nulCnt[j];
    }

    tmpCnt.mCount=nulRec;
    tmpCnt.uCount=nulRec;
    for(j=0; j<cat->cnt; j++){
      *(catList+j)='M';
      for(k=0; k<cls->cnt; k++) tmpCnt.mCnt[k]+=ValClsCnt(j,k);
      tmpCnt.mCount += *(valRecCnt+j);
    }
    calCndCnt(&tmpCnt);
    calCndCntSplit(&tmpCnt);
    cpyCndCnt(cnt,&tmpCnt);
    bestSv=tmpCnt.splitAfter;

    /*¤ꡢMatchUnmatch˥ƥ꡼ͤưƤ*/
    improve=1;
    while(improve) {
      improve=0;
      /*MatchĤİưɤʤ뤫ǧ*/
      for(j=0; j<cat->cnt; j++){
        if(*(catList+j)=='M'){
          /*MatchUnmatch˰ư*/
          for(k=0; k<cls->cnt; k++){
            tmpCnt.mCnt[k]-=ValClsCnt(j,k);
            tmpCnt.uCnt[k]+=ValClsCnt(j,k);
          }
          tmpCnt.mCount -=*(valRecCnt+j);
          tmpCnt.uCount +=*(valRecCnt+j);
          calCndCnt(&tmpCnt);
          calCndCntSplit(&tmpCnt);
          if(tmpCnt.splitAfter < bestSv){
            bestSv=tmpCnt.splitAfter;
            moveCat=j;
            improve=1;
          }
          /*MatchUnmatch˰ưΤ򸵤᤹*/
          for(k=0; k<cls->cnt; k++){
            tmpCnt.mCnt[k]+=ValClsCnt(j,k);
            tmpCnt.uCnt[k]-=ValClsCnt(j,k);
          }
          tmpCnt.mCount +=*(valRecCnt+j);
          tmpCnt.uCount -=*(valRecCnt+j);
        } /*if*/
      }

      /*СmoveCatUnmatch˰ư*/
      if(improve){
        *(catList+moveCat)='U';
        for(k=0; k<cls->cnt; k++){
          tmpCnt.mCnt[k]-=ValClsCnt(moveCat,k);
          tmpCnt.uCnt[k]+=ValClsCnt(moveCat,k);
        }
        tmpCnt.mCount -=*(valRecCnt+moveCat);
        tmpCnt.uCount +=*(valRecCnt+moveCat);
      }
    } /*while*/
    calCndCnt(&tmpCnt);
    calCndCntSplit(&tmpCnt);
    cpyCndCnt(cnt,&tmpCnt);

  }

  mssFree(valClsCnt);
  mssFree(valRecCnt);
  return(catList);
}

/**
 * # FUNCTION #
 * TreeΥΡɺƵؿ
 */
static struct Node *makeTree(
  struct Data     *dat,
  struct Cost     *cost,
  struct Pointer  *pointer,
  struct Node     *parent){

  struct Node  *this;
  struct CndCnt cnt;

  struct Pointer uPnt;
  struct Pointer mPnt;

  char *catList;

  double tmpTH;
  int match=0;
  int isNull=0;
  int i,j,jm,ju,jn;

  /*ȥΡΰγݤȽ*/
  this = mssCalloc(sizeof(struct Node), "Node");
  this->parent = parent;

  /* this->xxxCntν */
  iniCndCnt(&this->trnCnt,cost);

  /*splitting ruleͤν*/
  this->trnCnt.splitAfter=DBL_MAX;

  /*----------------------------------------------*/
  /*ѥܤˤǾȤ°դ*/
  /*----------------------------------------------*/
  for(i=0; i<dat->patCnt; i++){
    for(j=0; j<(dat->pat+i)->attCnt; j++){
      iniCndCnt(&cnt,cost);
      setCndCntPat(&cnt,dat->pat+i,*(dat->patNull+i),dat->cls,pointer,j);
      calCndCnt(&cnt);
      calCndCntSplit(&cnt);
      /*prnCndCnt(&cnt);*/

      /* ǾȤ°򹹿*/
      if(this->trnCnt.splitAfter > cnt.splitAfter){
        cpyCndCnt(&this->trnCnt,&cnt);
        this->attType =0;
        this->attFldNo=i;
        this->attPatNo=j;
      }
    }
  }

  /*----------------------------------------------*/
  /*͹ܤˤǾȤ°դ    */
  /*----------------------------------------------*/
  for(i=0; i<dat->numCnt; i++){
    iniCndCnt(&cnt,cost);
    tmpTH=setCndCntNum(&cnt,*(dat->num+i),*(dat->numNull+i),dat->cls,pointer,cost);
    calCndCnt(&cnt);
    calCndCntSplit(&cnt);
    /*prnCndCnt(&cnt);*/

    if(this->trnCnt.splitAfter > cnt.splitAfter){
      cpyCndCnt(&this->trnCnt,&cnt);
      this->attType =1;
      this->attFldNo=i;
      this->numTH = tmpTH;
    }
  }

  /*------------------------------------------------*/
  /*ƥ꡼ܤˤǾȤ°դ*/
  /*------------------------------------------------*/
  for(i=0; i<dat->catCnt; i++){
    iniCndCnt(&cnt,cost);
    catList=setCndCntCat(&cnt,dat->cat+i,*(dat->catNull+i),dat->cls,pointer,cost);
    calCndCnt(&cnt);
    calCndCntSplit(&cnt);

    if(this->trnCnt.splitAfter > cnt.splitAfter){
      cpyCndCnt(&this->trnCnt,&cnt);
      this->attType =2;
      this->attFldNo=i;
      mssFree(this->catList);
      this->catList = catList;
    }else{
      mssFree(catList);
    }
  }

  /*ΡɤΥ饹(꡼հʳǤ⥯饹ꤹΤϻ޴Τ)*/
  this->cls=dominantClass(&this->trnCnt);


  /*match, unmatchΥΡɤǤ줫NULLǡξLeaf&return*/
  if(this->trnCnt.mCount==this->trnCnt.nCount ||
     this->trnCnt.uCount==this->trnCnt.nCount ){
    this->nodeType=0;
    return(this);
  }


  /*ʤLeaf&return*/
  if(this->trnCnt.splitAfter >= this->trnCnt.splitBefor){
    this->nodeType=0;
    return(this);
  }

  /*줫0ξ,Leaf&return*/
  if(this->trnCnt.utCnt == 0 || this->trnCnt.mtCnt == 0){
    this->nodeType=0;
    return(this);
  }

  /*ξƤϤޤʤȤȤϥΡɤǤ*/
  this->nodeType = 1;
  /*prnCndCnt(&this->trnCnt);*/


  /*------------------------------------------------------*/
  /* ǡ(pointer)matchǡunmatchǡʬ*/
  /*------------------------------------------------------*/
  uPnt.recCnt = this->trnCnt.uCount;
  mPnt.recCnt = this->trnCnt.mCount;
  uPnt.recNo  = mssCalloc(uPnt.recCnt*sizeof(int),"uIdx");
  mPnt.recNo  = mssCalloc(mPnt.recCnt*sizeof(int),"mIdx");
  uPnt.weight = mssCalloc(uPnt.recCnt*sizeof(double),"uIdx");
  mPnt.weight = mssCalloc(mPnt.recCnt*sizeof(double),"mIdx");
  jm=0;
  ju=0;
  jn=0;

  for(i=0; i<pointer->recCnt; i++){
    switch(this->attType){
    case 0:
      isNull=*(*(dat->patNull+this->attFldNo)+*(pointer->recNo+i));
      break;
    case 1:
      isNull=*(*(dat->numNull+this->attFldNo)+*(pointer->recNo+i));
      break;
    case 2:
      isNull=*(*(dat->catNull+this->attFldNo)+*(pointer->recNo+i));
      break;
    }
    if( isNull ){
      *(mPnt.recNo +jm)=*(pointer->recNo+i);
      *(mPnt.weight+jm)=*(pointer->weight+i) * this->trnCnt.mRatio;
      *(uPnt.recNo +ju)=*(pointer->recNo+i);
      *(uPnt.weight+ju)=*(pointer->weight+i) * (1-this->trnCnt.mRatio);
      jm++;
      ju++;
      jn++;
    } else {
      switch(this->attType){
      case 0:
        match=(int)*((dat->pat+(this->attFldNo))->att[this->attPatNo]+*(pointer->recNo+i));
        break;
      case 1:
        match= *(*(dat->num+this->attFldNo)+*(pointer->recNo+i)) <= this->numTH;
        break;
      case 2:
        match= this->catList[*((dat->cat+this->attFldNo)->val+*(pointer->recNo+i))]=='M';
        break;
      }
      if( match ){
        *(mPnt.recNo +jm)=*(pointer->recNo+i);
        *(mPnt.weight+jm)=*(pointer->weight+i);
        jm++;
      }else{
        *(uPnt.recNo +ju)=*(pointer->recNo+i);
        *(uPnt.weight+ju)=*(pointer->weight+i);
        ju++;
      }
    }
  }

  /*----------------------------*/
  /*Ρɤ򿭤Ф(ƵƤӽФ)*/
  /*----------------------------*/
  this->mNode = makeTree(dat,cost,&mPnt,this);
  this->uNode = makeTree(dat,cost,&uPnt,this);

  /*ݥΰγ*/
  mssFree(uPnt.recNo);
  mssFree(uPnt.weight);
  mssFree(mPnt.recNo);
  mssFree(mPnt.weight);

  return(this);
}

/**
 * # SECTION #
 * ----------------------------------------------------------------------------
 * ޴ (Error-Based Pruning)
 * ----------------------------------------------------------------------------
 */

static double CF;

double Val[] = {  0,  0.001, 0.005, 0.01, 0.05, 0.10, 0.20, 0.40, 1.00};
double Dev[] = {100.0,3.09,  2.58,  2.33, 1.65, 1.28, 0.84, 0.25, 0.00};

/**
 * # FUNCTION #
 * ޴ ͽ¬ʬ׻(refered from C4.5)
 */
static double calEBPerr(double NN, double e){

  double coeff=0;
  double val0;
  int i;

  i=1;
  while(CF>Val[i])i++;
  coeff=Dev[i-1]+(Dev[i]-Dev[i-1]) * (CF-Val[i-1]) / (Val[i]-Val[i-1]);
  coeff=coeff * coeff;

  if(e<1E-6){
    return( NN * (1-exp(log(CF)/NN)) );
  }else if(e < 0.9999 ){
    val0=NN * (1-exp(log(CF)/NN));
    return(val0+e*(calEBPerr(NN,1.0)-val0) );
  }else if(e+0.5 >=NN){
    return( 0.67 * (NN-e) );
  }else{
    return( NN * ((e+0.5+coeff/2+sqrt(coeff*((e+0.5)*(1-(e+0.5)/NN)+coeff/4)))
                 /(NN+coeff)) -e  );
  }
}

/**
 * # FUNCTION #
 * Ρɤˤͽ¬ʬ(C4.5)׻ƥåȤ
 */
static void setEBPNodeErr(struct Node *node){
  double errCnt;
  int i;

  /*errorΥ*/
  errCnt=0;
  for(i=0; i<ClassSize; i++){
    if(i!=node->cls) errCnt += (double)node->trnCnt.total 
                              *(*(node->trnCnt.tShr+i));
  }
  node->estErrNode = calEBPerr((double)node->trnCnt.total,errCnt)+errCnt;

  /*꡼դʤХ꥿*/
  if( 0==node->nodeType ) return;

  setEBPNodeErr(node->uNode);
  setEBPNodeErr(node->mNode);
}

/**
 * # FUNCTION #
 * Ϳ줿Ρɰʲ꡼դˤͽ¬ʬ(C4.5)׻֤
 */
static double setEBPLeafErr(struct Node *node){

  if( 0==node->nodeType ) return(node->estErrNode);

  node->estErrLeaf= setEBPLeafErr(node->uNode)+setEBPLeafErr(node->mNode);
  return(node->estErrLeaf);
}

/**
 * # FUNCTION #
 * ޴¹
 */
static void pruneEBP(struct Node *node){

  if( 0==node->nodeType ) return;
  
  if(node->estErrLeaf > node->estErrNode ){
    node->pruned=1;
    return;
  }

  pruneEBP(node->uNode);
  pruneEBP(node->mNode);

  return;
}

/**
 * # FUNCTION #
 * ޴ Ʊ饹ͽ¬դĥΡɤϻ޴()
 */
static void pruneSameClass(struct Node *node){

  if( 0==node->nodeType ) return;

  if( 1==node->uNode->nodeType && !node->uNode->pruned )
    pruneSameClass(node->uNode);
  if( 1==node->mNode->nodeType && !node->mNode->pruned )
    pruneSameClass(node->mNode);

  /*ҤξȤ꡼դ⤷PrunedNodeξ硢ξȤƱ饹ʤ޴*/
  if( (0==node->uNode->nodeType || node->uNode->pruned) &&
      (0==node->mNode->nodeType || node->mNode->pruned) &&
      (node->uNode->cls == node->mNode->cls)            ){
    node->pruned=1;
    return;
  }
}

/**
 * # FUNCTION #
 * ΡǾ(optMIN.val)ʤΡɤϻ޴
 */
static void pruneMinCaseSize(struct Node *node){

  if( 0==node->nodeType ) return;

  if( 1==node->uNode->nodeType && !node->uNode->pruned )
    pruneMinCaseSize(node->uNode);
  if( 1==node->mNode->nodeType && !node->mNode->pruned )
    pruneMinCaseSize(node->mNode);

  /*ҤξȤ꡼դ⤷PrunedNodeξ硢ξȤƱ饹ʤ޴*/
  if( node->trnCnt.total < optMIN.val){
    node->pruned=1;
  }
}

/**
 * # FUNCTION #
 * ޴ᥤ
 */
static void pruneTree(struct Tree *tree,struct Cost *cost){

  /*ΡǾ(optMIN.val)ˤ޴*/
  if(optMIN.set){
    pruneMinCaseSize(tree->topNode);
  }

  /*Error-based Pruning*/
  CF=optCNF.val/(double)100;
  setEBPNodeErr(tree->topNode);
  setEBPLeafErr(tree->topNode);
  pruneEBP(tree->topNode);

  /*Ʊ饹Υ꡼դĥΡɤ޴*/
  pruneSameClass(tree->topNode);
}

/**
 * # SECTION #
 * ----------------------------------------------------------------------------
 * ɽϴؿ
 * ----------------------------------------------------------------------------
 */

/**
 * # FUNCTION #
 * ڤΥΡɤɽƵؿ
 */
static void showNode(
  struct Tree *tree,
  struct Node *node,
  char trl,          /* match or unmatch */
  struct mssFPW *fpw){

  char *clsNam;
  char *clsVal;
  double hitCnt=0;
  double supCnt=0;
  struct Category *catAdd;
  int firstWrite;
  int i;

  for(i=0; i<node->level; i++){
    mssWriteStr("  ",fpw);
  }
  switch(trl){
  case 'm': /*match*/
    mssWriteStr("then ",fpw);
    break;
  case 'u': /*unmatch*/
    mssWriteStr("else ",fpw);
    break;
  case 't': /*top Node*/
    break;
  }

  /*LeafʤХ饹̷ɽ & */
  if(node->nodeType==0 || node->pruned==1){
    clsNam = MssFlds2name(fcls,0);
    clsVal = tree->dat->cls->str[node->cls];
    hitCnt = node->trnCnt.tCnt[node->cls],
    supCnt = node->trnCnt.total;
    mssWriteStr("$",fpw);
    mssWriteStr(clsNam,fpw);
    mssWriteStr("=\"",fpw);
    mssWriteStr(clsVal,fpw);
    mssWriteStr("\" (hit/sup)=(",fpw);
    mssWriteDbl(hitCnt,fpw);
    mssWriteStr("/",fpw);
    mssWriteDbl(supCnt,fpw);
    mssWriteStr(")\n",fpw);
    return;
  }

  /*Ρɤʤ*/
  if(node->nodeType==1){
    switch(node->attType){
    case 0: /*pat*/
      mssWriteStr("if($",fpw);
      mssWriteStr(MssFlds2name(fpat,node->attFldNo),fpw);
      mssWriteStr(" has ",fpw);
      prnRegexp((tree->dat->pat+node->attFldNo)->regTbl->reg+node->attPatNo,fpw);
      mssWriteStr(")\n",fpw);
      break;
    case 1: /*num*/
      mssWriteStr("if($",fpw);
      mssWriteStr(MssFlds2name(fnum,node->attFldNo), fpw);
      mssWriteStr("<=",fpw);
      mssWriteDbl(node->numTH,fpw);
      mssWriteStr(")\n",fpw);
      break;
    case 2: /*category*/
      mssWriteStr("if($",fpw);
      mssWriteStr(MssFlds2name(fcat,node->attFldNo),fpw);
      mssWriteStr(" is in {",fpw);
      catAdd=tree->dat->cat+node->attFldNo;
      firstWrite=1;
      for(i=0; i<catAdd->cnt; i++){
        if(node->catList[i]=='M'){
          if(!firstWrite) mssWriteStr(",",fpw);
          else            firstWrite=0;
          mssWriteStr("\"",fpw);
          mssWriteStr(*(catAdd->valName+i),fpw);
          mssWriteStr("\"",fpw);
        }
      }
      mssWriteStr("})\n",fpw);
      break;
    }
  }
  showNode(tree,node->mNode,'m',fpw);
  showNode(tree,node->uNode,'u',fpw);
}

/**
 * # FUNCTION #
 * ѥʸȤ֤
 */
char *getRegStr(struct Regexp *reg){
  char buf[4096];
  char tmp[10];
  usint *str;

  buf[0]='\0';

  /*Ƭ*/
  if(reg->bgnRng!=0){
    strcat(buf,"^[");
    sprintf(tmp,"%d",reg->bgnRng);
    strcat(buf,tmp);
    strcat(buf,"] ");
  }

  str=reg->str;
  while(*str!=0){
    sprintf(tmp,"%d",*str++);
    strcat(buf,tmp);
    if(*str!=0) strcat(buf," ");
  }

  /**/
  if(reg->endRng!=0){
    strcat(buf,"$[");
    sprintf(tmp,"%d",reg->endRng);
    strcat(buf,tmp);
    strcat(buf,"]");
  }
  return(mssStrdup(buf));
}

/**
 * # FUNCTION #
 * ѥ°ΥΡɽ񤭽Ф
 */
void writePatPMML(
  struct Tree *tree,
  struct Node *node,
  char trl,          /* top or match or unmatch */
  struct mssFPW *fpw){

  struct mssXmlTag *tag;

  struct Regexp *reg;
  char *regStr;

  if(node->nodeType==0 || node->pruned==1) return;

  reg=(tree->dat->pat+node->attFldNo)->regTbl->reg+node->attPatNo;
  mssPMMLextensionStart("MUSASHI","patternPredicate",NULL,0,fpw);
  tag=mssInitXmlTag("X-PatternPredicate",NULL);
  mssAddXmlTagAttributeStr(tag,"x-field",MssFlds2name(fpat,node->attFldNo),NULL);
  if(reg->type==0){
    if(trl=='m'){
      mssAddXmlTagAttributeStr(tag,"x-operator","substring",NULL);
    }else{
      mssAddXmlTagAttributeStr(tag,"x-operator","notSubstring",NULL);
    }
  }else{
    if(trl=='m'){
      mssAddXmlTagAttributeStr(tag,"x-operator","notSubsequence",NULL);
    }else{
      mssAddXmlTagAttributeStr(tag,"x-operator","subsequence",NULL);
    }
  }
  regStr=getRegStr(reg);
  mssAddXmlTagAttributeStr(tag,"x-value",regStr,NULL);
  mssFree(regStr);
  mssPV.indentLevel++;
  mssPMMLindent(fpw);
  mssWriteXmlEmptyTag(tag,NULL,fpw);
  mssWriteRet(fpw); mssPV.outRetCnt++;
  mssPV.indentLevel--;

  mssPMMLextensionEnd(fpw);
}

/**
 * # FUNCTION #
 * °ΥΡɽ񤭽Ф
 */
void writeNumPMML(
  struct Tree *tree,
  struct Node *node,
  char trl,          /* top or match or unmatch */
  struct mssFPW *fpw){

  if(node->nodeType==0 || node->pruned==1) return;

  if(trl=='m'){
    mssPMMLsimplePredicateNumEmpty( MssFlds2name(fnum,node->attFldNo),
                                    "lessOrEqual", &node->numTH, fpw);
  }else{
    mssPMMLsimplePredicateNumEmpty( MssFlds2name(fnum,node->attFldNo),
                                    "greaterThan", &node->numTH, fpw);
  }
}

/**
 * # FUNCTION #
 * ƥ°ΥΡɽ񤭽Ф
 */
void writeCatPMML(
  struct Tree *tree,
  struct Node *node,
  char trl,          /* top or match or unmatch */
  struct mssFPW *fpw){

  struct Category *catAdd;
  char **str;
  int  cnt;
  int i;

  if(node->nodeType==0 || node->pruned==1) return;

  if(trl=='m'){
    mssPMMLsimpleSetPredicateStart( MssFlds2name(fcat,node->attFldNo),
                                    "isIn", fpw);
  }else{
    mssPMMLsimpleSetPredicateStart( MssFlds2name(fcat,node->attFldNo),
                                    "isNotIn", fpw);
  }


  catAdd=tree->dat->cat+node->attFldNo;
  cnt=0;
  for(i=0; i<catAdd->cnt; i++){
     if(node->catList[i]=='M') cnt++;
  }
  str=mssMalloc(sizeof(char *)*cnt,"writeCatPMML");

  cnt=0;
  for(i=0; i<catAdd->cnt; i++){
     if(node->catList[i]=='M') *(str+cnt++)=*(catAdd->valName+i);
  }
  mssPMMLarrayStr(&cnt, str, fpw);
  mssPMMLsimpleSetPredicateEnd(fpw);
  mssFree(str);
}

/**
 * # FUNCTION #
 * ڤΥΡɤɽƵؿ(PMML)
 */
static void showNodePMML(
  struct Tree *tree,
  struct Node *node,
  char trl,          /* top or match or unmatch */
  struct mssFPW *fpw){

  char *clsVal;


  /* <node score="will play" recordCount="14"> */
  clsVal = tree->dat->cls->str[node->cls];
  mssPMMLnodeStart(clsVal,&node->trnCnt.total,fpw);


  /* <predicate> */
  if(trl=='t'){
    mssPMMLtrueEmpty(fpw);
  }else{
    switch(node->parent->attType){
      case 0: writePatPMML(tree,node->parent,trl,fpw); break; /*pat*/
      case 1: writeNumPMML(tree,node->parent,trl,fpw); break; /*num*/
      case 2: writeCatPMML(tree,node->parent,trl,fpw); break; /*cat*/
    }
  }

  if(node->nodeType==0 || node->pruned==1){
    mssPMMLnodeEnd(fpw);
    return;
  }

  showNodePMML(tree,node->mNode,'m',fpw);
  showNodePMML(tree,node->uNode,'u',fpw);
  mssPMMLnodeEnd(fpw);

}


/**
 * # FUNCTION #
 * PMMLեޥåȤǷڤ
 */
void showTreePMML(struct Tree *tree,struct Cost *cost, struct mssFPW *fpw){

  struct mssXmlTag *tag;
  struct Map *map;
  char **str;
  int cnt;
  int ival;
  int i,j,k;

  /* PMMLϽ*/
  mssPMMLinit();

  /* <?xml version="1.0" encoding="EUC-JP"?> */
  mssWriteXmlDeclaration( MssXmlDefVer, MssXmlDefEnc ,fpw);
  mssPV.outRetCnt++;

  /* <PMML version="2.0"> */
  mssPMMLpmmlStart("2.0",fpw);

  /*   <Header copyright="MUSASHI" description="binary tree model"/> */
  mssPMMLheaderStart("MUSASHI",NULL,fpw);

  /*     <Application name="xtclassify" version="1.1"/> */
  mssPMMLapplicationEmpty(mssGV.comHelp->name,mssGV.comHelp->version,fpw);

  /*     <Timestamp>10 Jun 2003 13:16:15</Timestamp> */
  mssPMMLtimestamp(fpw);

  /*   </Header> */
  mssPMMLheaderEnd(fpw);


  /*   <DataDictionary numberOfFields="5">*/
  ival=optPAT.cnt+optNUM.cnt+optCAT.cnt+optCLS.cnt;
  mssPMMLdataDictionaryStart(&ival,fpw);

  /*     <DataField name="" optype="continuous">*/
  for(i=0; i<fnum->cnt; i++){
    mssPMMLdataFieldStart(MssFlds2name(fnum,i),NULL,"continuous",NULL,NULL,0,fpw);
    mssPMMLvalueStart(MssNullStr,NULL,"missing",1,fpw);
    mssPMMLdataFieldEnd(fpw);
  }

  /*     <DataField name="ŷ" optype="categorical">*/
  for(i=0; i<fcat->cnt; i++){
    mssPMMLdataFieldStart(MssFlds2name(fcat,i),NULL,"categorical",NULL,NULL,0,fpw);
    mssPMMLvalueStart(MssNullStr,NULL,"missing",1,fpw);
    mssPMMLdataFieldEnd(fpw);
  }

  /*     <DataField name="ѥ" optype="categorical">*/
  for(i=0; i<fpat->cnt; i++){
    mssPMMLdataFieldStart(MssFlds2name(fpat,i),NULL,"categorical",NULL,NULL,0,fpw);
    mssPMMLextensionStart("MUSASHI","optype","pattern",1,fpw);
    mssPMMLvalueStart(MssNullStr,NULL,"missing",1,fpw);
    mssPMMLdataFieldEnd(fpw);
  }

  /*     <DataField name="" optype="categorical">*/
  for(i=0; i<fcls->cnt; i++){
    mssPMMLdataFieldStart(MssFlds2name(fcls,i),NULL,"categorical",NULL,NULL,1,fpw);
  }

  /*   </DataDictionary>*/
  mssPMMLdataDictionaryEnd(fpw);

  /*<TreeModel functionName="classification">*/
  mssPMMLtreeModelStart(NULL,"classification",NULL,"binarySplit",fpw);

  /*<MiningSchema>*/
  mssPMMLminingSchemaStart(fpw);
  mssPMMLminingFields(fnum,NULL,NULL,NULL,NULL,NULL,"asMean",fpw);
  mssPMMLminingFields(fcat,NULL,NULL,NULL,NULL,NULL,"asMean",fpw);
  for(i=0; i<fpat->cnt; i++){
    mssPMMLminingFieldStart(MssFlds2name(fpat,i),NULL,NULL,NULL,NULL,NULL,NULL,0,fpw);

    mssPMMLextensionStart("MUSASHI","patternIndex",NULL,0,fpw);
    map=(tree->dat->pat+i)->map;
    for(j=0; j<map->idxSiz; j++){
      /*</X-PatternIndex x-index="1">*/
      tag=mssInitXmlTag("X-PatternIndex",NULL);
      mssAddXmlTagAttributeInt(tag,"x-index",j+1,NULL);
      mssPV.indentLevel++;
      mssPMMLindent(fpw);
      mssWriteXmlStartTag(tag,NULL,fpw);
      mssWriteRet(fpw); mssPV.outRetCnt++;

      /*<Array n="3" type="string">aa bb cc</Array>*/
      /*ĤΥǥå˴ޤޤ륢ե٥åȤη򥫥*/
      cnt=0;
      for(k=0; k<map->alpSiz; k++){
        if(*(map->idx+k) == (usint)(j+1) ) cnt++;
      }
      /*ĤΥǥå˴ޤޤ륢ե٥åȤΥɥ쥹Ͽ*/
      str=mssMalloc(sizeof(char *)*cnt,"showTreePMML");
      cnt=0;
      for(k=0; k<map->alpSiz; k++){
        if(*(map->idx+k) == (usint)(j+1) ){
          *(str+cnt++)=*(map->numAlp+k);
        }
      }
      mssPMMLarrayStr(&cnt, str, fpw);
      mssFree(str);

      /*</X-PatternIndex>*/
      mssPMMLindent(fpw);
      mssWriteXmlEndTag(tag,NULL,fpw);
      mssWriteRet(fpw); mssPV.outRetCnt++;
      mssPV.indentLevel--;
    }
    mssPMMLextensionEnd(fpw);
    mssPMMLminingFieldEnd(fpw);
  }
  mssPMMLminingFields(fcls,"predicted",NULL,NULL,NULL,NULL,NULL,fpw);
  mssPMMLminingSchemaEnd(fpw);

  showNodePMML(tree,tree->topNode,'t',fpw);

  mssPMMLtreeModelEnd(fpw);

  /* </PMML> */
  mssPMMLpmmlEnd(fpw);

  mssGV.outCnt=mssPV.outRetCnt;
}

/**
 * # FUNCTION #
 * ƥȤǷڤ
 *  1.Command Line
 *  2.Cost Matrix
 *  3.Alphabet-Index
 *  4.Decision Tree
 *  5.Classification Table
 *  6.Summary
 */
void showTree(struct Tree *tree,struct Cost *cost, struct mssFPW *fpw){
  int i,j,k;
  int firstWrite;
  struct Map *map;

  j=0;
  mssWriteStr("=================================\n",fpw);
  mssWriteStr("RESULT on xtclassify\n",fpw);
  mssWriteStr("=================================\n",fpw);
  mssWriteStr("[Command Line]\n",fpw);

  for(i=0; i<mssGV.argc; i++){
    mssWriteStr(*(mssGV.argv+i),fpw);
    mssWriteStr(" ",fpw);
  }
  mssWriteRet(fpw);
  mssWriteRet(fpw);

  if(optCST.set){
    showCost(cost,fpw);
    mssWriteRet(fpw);
  } 

  if(optPAT.set){
    mssWriteStr("[Random Seed]\n",fpw);
    mssWriteInt(usedRandSeed,fpw);
    mssWriteRet(fpw);
    mssWriteRet(fpw);

    mssWriteStr("[Alphabet-Index]\n",fpw);
    for(i=0; i<tree->dat->patCnt; i++){
      map=(tree->dat->pat+i)->map;
      mssWriteStr("Field Name: $",fpw);
      mssWriteStr(MssFlds2name(fpat,i),fpw);
      mssWriteRet(fpw);

      for(j=0;j<map->idxSiz;j++){
        mssWriteStr("Index[",fpw);
        mssWriteInt(j+1,fpw);
        mssWriteStr("]={",fpw);
        firstWrite=1;
        for(k=0; k<map->alpSiz; k++){
          if(*(map->idx+k) == (usint)(j+1) ){
            if(!firstWrite) mssWriteStr(",",fpw);
            else            firstWrite=0;
            mssWriteStr("\"",fpw);
            mssWriteStr(*(map->numAlp+k),fpw);
            mssWriteStr("\"",fpw);
          }
        }
        mssWriteStr("}\n",fpw);
      }
    }    
    mssWriteStr("\n",fpw);
  }

  mssWriteStr("[Decision Tree]\n",fpw);
  showNode(tree,tree->topNode,'t',fpw);
  mssWriteRet(fpw);
  mssWriteStr("numberOfLeaves=",fpw);
  mssWriteInt(tree->leafCnt,fpw);
  mssWriteRet(fpw);
  mssWriteStr("deepestLevel=",fpw);
  mssWriteInt(tree->deepest,fpw);
  mssWriteRet(fpw);
  mssWriteRet(fpw);

  mssWriteStr("[Confusion Matrix]\n",fpw);
  mssWriteStr("## TRAINING DATA ##\n",fpw);
  showClsTbl(tree->trnRsl,tree->dat,fpw);
  mssWriteRet(fpw);

  if(optTST.set){
    mssWriteStr("## TEST DATA ##\n",fpw);
    showClsTbl(tree->tstRsl,tree->dat,fpw);
    mssWriteRet(fpw);
  }
}

/**
 * # SECTION #
 * ----------------------------------------------------------------------------
 * API
 *   1.decisionTree
 *   2.updateTree
 *   3.freeTree
 * ----------------------------------------------------------------------------
 */

/**
 * # FUNCTION #
 * ᥤ롼
 */
struct Tree *decisionTree(
  struct Data *trn,   /*ȥ졼˥󥰥ǡ*/
  struct Data *tst,   /*ƥȥǡ*/
  struct Cost *cost){ /*ɽ*/

  struct Tree   *tree;
  struct Pointer pointer; /*ĥ꡼ѤattTblΥǥå*/
  int i;

  tree = mssCalloc(sizeof(struct Tree),"tree");

  /*pointerĤ*/
  pointer.recCnt=trn->cnt;
  pointer.recNo =mssCalloc(trn->cnt * sizeof(int),"decTreePointer");
  pointer.weight=mssCalloc(trn->cnt * sizeof(double),"decTreePointer");
  for(i=0; i<trn->cnt; i++){
    *(pointer.recNo+i)=i;
    *(pointer.weight+i)=1;
  }
  tree->topNode   = makeTree(trn,cost,&pointer,NULL);
  mssFree(pointer.recNo);
  mssFree(pointer.weight);

  /*ץǡ¤ΤΥԡ(ºݤmapHash,mapTbl,cat->catListΤߥԡ)*/
  tree->dat=cpyDatMapReg(trn);

  /*޴*/
  pruneTree(tree,cost);

  /*ĥ꡼¤ΤγƼѿΥå*/
  setLevel(tree->topNode,tree,0);

  /*ɽκ(ȥ졼˥)*/
  tree->trnRsl=setClsTbl( trn, tree);
  calClsTbl(tree->trnRsl,cost); /*Ƽ͡ɸ׻*/

  /*ɽκ(ƥ)*/
  tree->tstRsl=setClsTbl( tst, tree);
  calClsTbl(tree->tstRsl,cost); /*Ƽ͡ɸ׻*/

  return(tree);
}

/**
 * # FUNCTION #
 * ĥ꡼¤Τΰ
 */
void freeTree(struct Tree *tree){
  struct Node **nodeTbl=NULL;
  int           nodeCnt=0;
  int i;

  if(tree==NULL)return;
  nodeTbl=freeTreeTbl(tree->topNode,nodeTbl,&nodeCnt);

  for(i=0; i<nodeCnt; i++){
   mssFree(*(nodeTbl+i));
  }
  mssFree(nodeTbl);
  mssFree(tree->topNode);
  freeDatMapReg(tree->dat);
  mssFree(tree->trnRsl);
  mssFree(tree->tstRsl);
  mssFree(tree);
}

/**
 * # FUNCTION #
 * 褤ĥ꡼ι
 */
struct Tree *updateTree(
  struct Tree *tree,
  struct Tree *betterTree){

  /*NULLȽ*/
  if(tree==NULL){
    return(betterTree);
  }else if(betterTree==NULL){
    return(tree);

  /*Ȥ*/
  }else if(tree->trnRsl->tCst < betterTree->trnRsl->tCst){
    freeTree(betterTree);
    return(tree);
  }else if(tree->trnRsl->tCst > betterTree->trnRsl->tCst){
    freeTree(tree);
    return(betterTree);

  /*ȤƱϥ*/
  }else{
    if(tree->leafCnt < betterTree->leafCnt){
      freeTree(betterTree);
      return(tree);
    }else{
      freeTree(tree);
      return(betterTree);
    }
  }
  return(NULL); /*to avoid warning*/
}

/**
 * # FUNCTION #
 * вɽ
 */
void showProgressTree(struct Data *dat, struct Tree *tree){
  int i;
  char buf[MssRecordMaxLen];
  char *num[]={"0","1","2","3","4","5","6","7","8","9"};
  usint *str;

  buf[0]='\0';
  strcat(buf,"index:");
  for(i=0; i<dat->patCnt; i++){
    str=(dat->pat+i)->map->idx;
    while(*str!=0){
      strcat(buf,num[*str++]);
    }
    strcat(buf," ");
  }
  mssShowMsg("%scost=%f geoMean=%f leafCnt=%d",buf,tree->tstRsl->tCst,tree->tstRsl->geoMean,tree->leafCnt);
}

