
#include "commonHelp.h"
/*============================================================================*/
/* コマンドヘルプ,man,musahi GUI 共通メッセージ管理                           */
/*============================================================================*/
/*----------------------------------------------------------------------------*/
/* コマンドのタイトル                                                         */
/* コマンドヘルプの最初の行に表示                                             */
/*----------------------------------------------------------------------------*/
#define HELPT "参照ファイルの複数範囲条件による自然結合"

/*----------------------------------------------------------------------------*/
/* パラメータ                                                                 */
/* コマンドヘルプの USAGE:として"キーワード XXXT"を表示 ex)-k キー項目名リスト*/
/* flagのオプションはコマンドヘルプのOPTIONS)として表示 ex)-z : 標準出力の圧縮*/
/*----------------------------------------------------------------------------*/
/*-k*/
#define TKYT "入力データ上の突き合わせる項目名リスト"
#define TKYC "ここで指定した入力データの項目と-Kで指定された参照データの項目が同じ行の項目結合が行われる"

/*-K*/
#define MKYT "参照データ上の突き合わせる項目名リスト"
#define MKYC "ここで指定した参照データの項目と-kで指定された入力データの項目が同じ行の項目結合が行われる"

/*-m*/
#define MSTT "参照ファイル名"
#define MSTC "参照ファイル名を指定する"

/*-r*/
#define VALT "範囲比較される項目名"
#define VALC "入力ファイル上の項目名"
#define VALF "数値"

/*-R*/
#define RNGT "範囲項目名"
#define RNGC "参照ファイル上の範囲項目名(start,end)"
#define RNGF "イコールを含む,イコールを含まない"

/*-f*/
#define FLDT "結合項目名リスト"
#define FLDC "結合する参照ファイル上の項目名リスト"
#define FLDF NULL

/*-n*/
#define TNLT "キー未結合入力データ出力"
#define TNLC "参照データにない入力データをNULL値として出力するフラグ"

/*-N*/
#define RNLT "範囲未結合入力データ出力"
#define RNLC "参照データにない範囲データをNULL値として出力するフラグ"

/*-i*/
#define INFT C_INFT
#define INFC C_INFC

/*-o*/
#define OTFT C_OTFT
#define OTFC C_OTFC

/*-z*/
#define ZIPT C_ZIPT
#define ZIPC C_ZIPC

/*-t*/
#define TXTT C_TXTT
#define TXTC C_TXTC

/*-T*/
#define TMPT C_TMPT
#define TMPC C_TMPC

/*----------------------------------------------------------------------------*/
/* 要約                                                                       */
/* コマンドヘルプのSUMMARY:として表示する                                     */
/* HTMLヘルプやmanには、下のHELPDの上に結合する形で表示する                   */
/*----------------------------------------------------------------------------*/
#define HELPS "範囲により参照ファイルの項目を結合(join)する。-kで指定した入力ファイルの項目値と-Kで指定した参照ファイルの項目値が同じ行について、-rで指定した項目値が-Rで指定した2項目の値の範囲条件(項目1以上項目2未満)にマッチすれば、-fの項目を結合する。マッチする行が複数あれば、それらの行全てが出力され、ちょうど自然結合のような動きをする。範囲比較される値は、デフォルトで文字列と見なされる。数値として処理したい場合は-rの項目名のあとに%nをつけること。"

/*----------------------------------------------------------------------------*/
/* 例                                                                         */
/*----------------------------------------------------------------------------*/
#define HELPE "\
xtnrjoin -v 金額%n -m ref.xt -R 金額F,金額T -f クラス -i dat.xt -o rsl.xt\n\
xtnrjoin -k 店 -v 金額%n -m ref.xt -R 金額F%n,金額T%e -f クラス -i dat.xt -o rsl.xt\n\
xtnrjoin -v 金額%n -m ref.xt -R 金額F,金額T -f クラス -nN -i dat.xt -o rsl.xt\n\
"

/*----------------------------------------------------------------------------*/
/* 参照コマンド(必ずカンマで区切り、空白は用いない)                           */
/*----------------------------------------------------------------------------*/
#define HELPR "xtjoin,xtrjoin,xtproduct,xtcommon"

/*----------------------------------------------------------------------------*/
/* 作者について                                                               */
/* コマンドヘルプには表示されない                                             */
/*----------------------------------------------------------------------------*/
#define HELPA C_HELPA

/*----------------------------------------------------------------------------*/
/* バグレポート                                                               */
/* ここを登録すればコマンドヘルプのBUG REPORT:に表示される。                  */
/* 登録がなければ(#define HELPB "")何も表示しない。                           */
/*----------------------------------------------------------------------------*/
#define HELPB C_HELPB

/*----------------------------------------------------------------------------*/
/* ホームページ                                                               */
/* ここを登録すればコマンドヘルプのINFORMATION:に表示される。                 */
/* 登録がなければ(#define HELPH "")何も表示しない。                           */
/*----------------------------------------------------------------------------*/
#define HELPH C_HELPH
